<template lang="pug">
	#operaciones(:class="modo")
		.barra
			.panel
				input(v-model="nombre", placeholder="Sin Nombre")

			.panel.general
				button(type="button", @click="nuevo")
					span Limpiar
					NewspaperIcon

			.panel
				button(type="button", @click="guardar")
					span Guardar
					SaveIcon


			.panel.elemento(v-if="elemento && modo=='editor'")
				button(type="button", @click="borrar")
					span Borrar
					TrashIcon
				button(type="button", @click="subir")
					span Traer adelante
					ArrowUpIcon
				button(type="button", @click="bajar")
					span Enviar atras
					ArrowDownIcon

		.barra
			.panel.tabs
				button(
					type="button",
					v-for="item, i in items",
					:class="{actual:actual==i}"
					@click="itemClick(i)"
					:key="i")
					file-icon
					span Hoja {{i+1}}
					button.borrar(
						v-if="items.length > 1",
						@click="itemBorrarClick(i)"
						)
						x-icon.text-red-900(size="12")
				button.nuevo(
					v-if="modo=='editor'",
					@click="nuevoItemClick")
					file-plus-icon

			.panel.usuario
				.grupo
					button(type="button", @click="listaExportar=!listaExportar")
						span Exportar
						file-download-icon
					.desplegable(:class="{abierto:listaExportar}")
						button(type="button", @click="imagenClick")
							span Imagen
							photo-icon
						button(type="button", @click="pdfClick")
							span Pdf
							file-text-icon


</template>

<script>
import Vue from 'vue'
import { ArrowUpIcon,ArrowDownIcon,NewspaperIcon,SaveIcon, TrashIcon  } from "@vue-hero-icons/outline"
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex'

export default {
	components:{
		TrashIcon,
		ArrowUpIcon,
		ArrowDownIcon,
		SaveIcon,
		NewspaperIcon
	},
	data: () => ({
		listaExportar: false
	}),
	computed:{
		nombre:{
			get(){ return this.contenido.nombre},
			set(valor){ this.establecerNombre(valor) }
		},
		...mapState({
			contenido: "contenido",
			modo: state => state.editor.modo,
			items: state => state.contenido.items,
			actual: state => state.contenido.actual,

		}),
		...mapGetters({
			elemento: "contenido/activo"
		})
	},
	methods:{
		borrar(){
			this.eliminar()
		},
		imagenClick(){
			this.descargarImagen()
			this.listaExportar = false
		},
		pdfClick(){
			this.descargarPDF()
			this.listaExportar = false
		},
		nuevo(){
			this.cargar([{
				ancho: 500,
				alto: 500,
				fondo: "#FFFFFF",
				objetos: [],
			}])

			this.actualizarID(null)
		},
		nuevoItemClick(){
			this.nuevoItem()
		},
		itemClick(id){
			this.cambiarActual(id)
		},
		itemBorrarClick(id){
			Vue.swal({
				title: `Eliminar la Hoja Nº ${id + 1}`,
				text: "Se perderán todos los contenidos de esta hoja, esta operación no se puede deshacer",
				icon: "question",
				showCancelButton: true,
				cancelButtonText: "Cancelar",
				confirmButtonText: "Borrar",
				confirmButtonColor: "#dd3033"
			})
			.then((rpta) => {
				console.log(rpta)
				if(rpta.isConfirmed){
					this.borrarItem(id)
				}

			});

		},
		async guardar(){
			// const nombre = Math.random().toString(36).substring(7).toUpperCase()
			// console.debug("guardar", nombre)
			// alert(nombre)
			// console.log(this.contenido.items)

			// this.$axios.$post("https://remaxdesignperu.com/system/patrones/guardar", {
			// 	nombre,

			// 	contenido: this.contenido.items,
			// 	id: this.contenido.id
			// })
			// .then(response => {
			// 	this.actualizarID(parseInt(response.id))
			// 	console.log(response)
			// 	alert("Guardado con éxito")
			// })
			// .catch(function (error) {
			// 	console.log(error);
			// });
			await this.actualizarPrevio()
			// this.guardarContenido(nombre)
			if(this.modo == "usuario"){
				await this.guardarContenido()

			}else{
				await this.guardarPlantilla()
			}



		},
		// subir(){
		// 	this.eliminar()
		// },
		// bajar(){
		// 	this.eliminar()
		// },
		...mapActions({
			eliminar: "editor/eliminarElemento",
			actualizarPrevio: "editor/actualizarPrevio",
			guardarContenido: "editor/guardarContenido",
			guardarPlantilla: "editor/guardarPlantilla",
			descargarImagen: "editor/descargarImagen",
			descargarPDF: "editor/descargarPDF",
		}),

		...mapMutations({
			subir: "contenido/subirElemento",
			bajar: "contenido/bajarElemento",
			cargar: "contenido/cargar",
			actualizarID: "contenido/actualizarID",
			establecerNombre: "contenido/establecerNombre",
			nuevoItem: "contenido/nuevoItem",
			borrarItem: "contenido/borrarItem",
			cambiarActual: "contenido/actual",
		})
	},
	mounted(){
			this.actualizarID(null)
	}
}
</script>


<style lang="stylus" scoped>
#operaciones
	display block

.barra
	display flex
	align-items stretch
	flex-wrap wrap
	gap 0px 20px

.panel
	padding .2rem 0
	display flex
	align-items stretch
	gap .1em

	&.general
		.usuario &
			display none

	&.usuario
		margin-left auto

		.editor &
			display none

	& + .panel
		// margin-left 20px

#operaciones
	background-color #082B8D

button
	background-color #014492
	border 1px solid silver
	margin 0
	padding .5em
	border-radius 0.2em
	border none
	line-height 1
	color white
	display flex
	font-size 13px
	justify-content center
	align-items center

	&:hover
		background-color tint(#014492, 10%)

button span
	margin-right 5px

.grupo
	position relative

.desplegable
	position absolute
	top 100%
	left 0
	right 0

	z-index 1
	display flex
	flex-direction column
	align-items stretch
	pointer-events none
	opacity 0

	&.abierto
		opacity 1
		pointer-events auto

input
	font-size 12px
	padding .2em .5em
	border-radius 0.2em
	background-color silver

	&:focus
		background-color white

.tabs
	display flex
	padding 0
	gap .1rem
	align-items flex-end
	button
		margin 0
		border-radius .2rem .2rem 0 0

		&.actual
			background-color white
			color #014492

	.borrar
		background-color silver
		padding .1rem
		border-radius .2em
		line-height 1

</style>
